## ros-lunar-novatel-gps-driver 3.8.0

=== CMakeLists.txt ===
cmake_minimum_required(VERSION 2.8.3)

project(novatel_gps_driver)

set(DEPS
  diagnostic_msgs 
  diagnostic_updater 
  gps_common
  nav_msgs 
  nodelet 
  novatel_gps_msgs
  roscpp
  sensor_msgs
  std_msgs
  swri_math_util 
  swri_roscpp
  swri_serial_util
  swri_string_util 
  tf
)

set(BUILD_DEPENDS
  ${DEPS}
  swri_nodelet
)

find_package(catkin REQUIRED COMPONENTS ${BUILD_DEPENDS})

find_package(Boost REQUIRED COMPONENTS system)

include_directories(include
  ${catkin_INCLUDE_DIRS}
)

# libpcap doesn't provide PkgConfig or CMake modules
find_library(libpcap_LIBRARIES pcap)
if ("${libpcap_LIBRARIES}" STREQUAL "pcap-NOTFOUND")
  set(libpcap_FOUND FALSE)
else()
  set(libpcap_FOUND TRUE)
endif()

catkin_package(CATKIN_DEPENDS ${DEPS}
  INCLUDE_DIRS include
  LIBRARIES ${PROJECT_NAME} ${PROJECT_NAME}_nodelets
  DEPENDS Boost libpcap
)

add_library(${PROJECT_NAME} 
  src/novatel_gps.cpp
  src/novatel_message_extractor.cpp
  src/parsers/bestpos.cpp
  src/parsers/bestutm.cpp
  src/parsers/bestvel.cpp
  src/parsers/corrimudata.cpp
  src/parsers/clocksteering.cpp
  src/parsers/gpgga.cpp
  src/parsers/gpgsa.cpp
  src/parsers/gpgsv.cpp
  src/parsers/gprmc.cpp
  src/parsers/header.cpp
  src/parsers/inscov.cpp
  src/parsers/inspva.cpp
  src/parsers/inspvax.cpp
  src/parsers/insstdev.cpp
  src/parsers/parsing_utils.cpp
  src/parsers/range.cpp
  src/parsers/time.cpp
  src/parsers/trackstat.cpp
)

add_dependencies(${PROJECT_NAME} ${catkin_EXPORTED_TARGETS})

target_link_libraries(${PROJECT_NAME}
  ${catkin_LIBRARIES}
  ${Boost_LIBRARIES}
  ${libpcap_LIBRARIES}
)
set_target_properties(${PROJECT_NAME} PROPERTIES COMPILE_FLAGS "-std=c++11")

### Nodelets ###
add_library(${PROJECT_NAME}_nodelets 
  src/nodelets/novatel_gps_nodelet.cpp
)
target_link_libraries(${PROJECT_NAME}_nodelets
  ${catkin_LIBRARIES}
  ${PROJECT_NAME}
)
set_target_properties(${PROJECT_NAME}_nodelets PROPERTIES COMPILE_FLAGS "-std=c++11")

### Nodes ###
swri_nodelet_add_node(novatel_gps_node ${PROJECT_NAME} NovatelGpsNodelet)
target_link_libraries(novatel_gps_node
  ${catkin_LIBRARIES}
  ${PROJECT_NAME}_nodelets
)
set_target_properties(novatel_gps_node PROPERTIES COMPILE_FLAGS "-std=c++11")

### Build unit tests
if(CATKIN_ENABLE_TESTING)
  find_package(rostest REQUIRED)

  catkin_add_gtest(parser_tests test/parser_tests.cpp)
  target_link_libraries(parser_tests ${PROJECT_NAME})
  set_target_properties(parser_tests PROPERTIES COMPILE_FLAGS "-std=c++11")

  add_rostest_gtest(novatel_gps_tests test/novatel_gps_tests.test test/novatel_gps_tests.cpp)
  target_link_libraries(novatel_gps_tests ${PROJECT_NAME})
  set_target_properties(novatel_gps_tests PROPERTIES COMPILE_FLAGS "-std=c++11")
endif()

### Install Libraries and Headers ###
install(TARGETS 
    novatel_gps_node
    ${PROJECT_NAME} 
    ${PROJECT_NAME}_nodelets
  ARCHIVE DESTINATION ${CATKIN_PACKAGE_LIB_DESTINATION}
  LIBRARY DESTINATION ${CATKIN_PACKAGE_LIB_DESTINATION}
  RUNTIME DESTINATION ${CATKIN_PACKAGE_BIN_DESTINATION}
)
install(DIRECTORY include/${PROJECT_NAME}/
  DESTINATION ${CATKIN_PACKAGE_INCLUDE_DESTINATION}
)

### Install plugin XML ###
install(FILES nodelet_plugins.xml
  DESTINATION ${CATKIN_PACKAGE_SHARE_DESTINATION}
)

### Install Launch Files ###
install(DIRECTORY launch DESTINATION ${CATKIN_PACKAGE_SHARE_DESTINATION})

=== debian/changelog ===
ros-lunar-novatel-gps-driver (3.8.0-1xenial) xenial; urgency=high

  * Add fix for messages build order (#41 <https://github.com/swri-robotics/novatel_gps_driver/issues/41>)
  * Add clocksteering parsing (#40 <https://github.com/swri-robotics/novatel_gps_driver/issues/40>)
  * Only unlogall for the current port (#36 <https://github.com/swri-robotics/novatel_gps_driver/issues/36>)
  * Contributors: Matthew, P. J. Reed

 -- P. J. Reed <preed@swri.org>  Tue, 04 Jun 2019 05:00:00 -0000

ros-lunar-novatel-gps-driver (3.7.0-1xenial) xenial; urgency=high

  * Added IMU: Honeywell HG4930 AN01 (#31 <https://github.com/swri-robotics/novatel_gps_driver/issues/31>)
  * Added launch file to test an Ethernet interface. (#33 <https://github.com/swri-robotics/novatel_gps_driver/issues/33>)
  * Contributors: Rinda Gunjala, Zach Oakes

 -- P. J. Reed <preed@swri.org>  Fri, 22 Mar 2019 05:00:00 -0000

ros-lunar-novatel-gps-driver (3.6.0-1xenial) xenial; urgency=high

  * Allow setting the serial baud rate through serial_baud ROS parameter
  * Add support for BESTUTM log
  * Add support for INSPVAX log (#27)
  * Contributors: Ellon Paiva Mendes, Sagnik Basu

 -- P. J. Reed <preed@swri.org>  Tue, 09 Oct 2018 05:00:00 -0000

ros-lunar-novatel-gps-driver (3.5.0-1xenial) xenial; urgency=high

  * Update documentation
  * Fix parsing of gprmc messages for OEM4 models (#22)
  * Finish serial commands with [CR][LF] (Carriage-Return Line-Feed) (#21)
  * Adds configuration parameter span_frame_to_ros_frame. (#20)
  * Adds additional IMUs defined in the OEM7 firmware. (#17)
  * Enable the driver to determine IMU sample rate from the IMU type (#9)
  * Contributors: Ellon Paiva Mendes, Joshua Whitley, Matthew, P. J. Reed

 -- P. J. Reed <preed@swri.org>  Tue, 17 Jul 2018 05:00:00 -0000

ros-lunar-novatel-gps-driver (3.4.0-1xenial) xenial; urgency=high

  * Fixes RPY orientation in IMU output (based on testing).
  * Add service to novatel_gps_nodelet that issues a FRESET command on the indicated target, or STANDARD if none is provided
  * Use find_library to look up the location of libpcap.so
  * Contributors: Joshua Whitley, Matthew Bries, P. J. Reed

 -- P. J. Reed <preed@swri.org>  Fri, 06 Oct 2017 05:00:00 -0000

ros-lunar-novatel-gps-driver (3.3.0-1xenial) xenial; urgency=high

  * Fix crash for unexpected position type
  * Add three-clause BSD license
  * Publish sensor_msgs/Imu messages
  * Use unlogall true
  * Code cleanup
  * Contributors: Edward Venator, P. J. Reed

 -- P. J. Reed <preed@swri.org>  Thu, 31 Aug 2017 05:00:00 -0000

ros-lunar-novatel-gps-driver (3.2.0-1xenial) xenial; urgency=high

  * Use size_t responsibly
  * Remove duplicate message ID definition
  * Reorganize parsing code
  * Add binary message support
  * Publish IMU data from NovAtel SPAN devices
  * Contributors: Edward Venator, P. J. Reed

 -- P. J. Reed <preed@swri.org>  Fri, 21 Jul 2017 05:00:00 -0000

ros-lunar-novatel-gps-driver (3.1.0-1xenial) xenial; urgency=high

  * Add ethernet support
  * Binary message support
  * Contributors: P. J. Reed

 -- P. J. Reed <preed@swri.org>  Tue, 27 Jun 2017 05:00:00 -0000

ros-lunar-novatel-gps-driver (3.0.1-1xenial) xenial; urgency=high

  * Set UTC time correctly for message syncing
  * Contributors: Edward Venator

 -- P. J. Reed <preed@swri.org>  Mon, 08 May 2017 05:00:00 -0000

ros-lunar-novatel-gps-driver (3.0.0-1xenial) xenial; urgency=high

  * Rename novatel_msgs to novatel_gps_msgs
  * Fix catkin_lint warnings
  * Add novatel_msgs as a dep to novatel_oem628
  * Add support for Novatel Trackstat messages
  * Remove debug error messages.
  * Add gpgsv support to novatel driver nodelet.
  * Add support for GPGSV messages in driver library.
  * Add support for GPGSV message in novatel parser.
  * Add support to ROS driver for Time message publishing
  * Add support for accessing Time messages.
  * Move messages into separate package.
  * Update nodelet documentation.
  * Add support for Novatel BESTVELA to ROS driver.
  * Add support for BESTVELA to Novatel driver
  * Add support for bestvel to message parser.
  * Add new message for BESTVEL
  * Add support for GPGSA messages.
  * Add support to configure the Novatel GPS driver for any message type and frequency.
  * Contributors: Edward Venator, P. J. Reed

 -- P. J. Reed <preed@swri.org>  Mon, 03 Apr 2017 05:00:00 -0000

ros-lunar-novatel-gps-driver (2.9.0-1xenial) xenial; urgency=high

  * Clean up wait_for_position member variable usage
  * Merge repos on dismount and ivs; also fix some warnings
  * Move GitLab CI config to correct location.
  * Enable GitLab CI.
  * Fix potential issue with how utc offset is applied.
  * Change to always try to configure the device.
  * Fix NMEA/novatel message synchronization issues
  * Widening synchronization tolerance
  * Switch to from *_util to swri_*_util.
  * Update example launch file for novatel nodelet.
  * Contributors: Edward Venator, Jerry Towler, Kris Kozak, Marc Alban, P. J. Reed

 -- P. J. Reed <preed@swri.org>  Wed, 11 Jan 2017 06:00:00 -0000

ros-lunar-novatel-gps-driver (2.8.0-1xenial) xenial; urgency=high

  * Remove explicit serial device name check
  * Add param to not publish sync diagnostic
  * Contributors: Jason Gassaway, P. J. Reed

 -- P. J. Reed <preed@swri.org>  Thu, 05 Jan 2017 06:00:00 -0000

ros-lunar-novatel-gps-driver (2.7.2-1xenial) xenial; urgency=high

  * fixes issue caused by previous commit - no gps fix msgs being published
    previous commit caused no gps fix msgs to be published because msg buffers
    were small, and position msg arrived > 1 sec later than gpgga and gprmc msgs
    such that msgs were never synced. Added parameters to specify time sync
    tolerances and to optionally not wait for position msg. Position msg is not
    critical, it is only used to set position_covariance matrix.
  * Contributors: Neal Seegmiller

 -- P. J. Reed <preed@swri.org>  Mon, 28 Nov 2016 06:00:00 -0000



=== debian/control ===
Source: ros-lunar-novatel-gps-driver
Section: misc
Priority: extra
Maintainer: P. J. Reed <preed@swri.org>
Build-Depends: debhelper (>= 9.0.0), libboost-all-dev, libpcap0.8-dev, ros-lunar-catkin, ros-lunar-diagnostic-msgs, ros-lunar-diagnostic-updater, ros-lunar-gps-common, ros-lunar-nav-msgs, ros-lunar-nodelet, ros-lunar-novatel-gps-msgs, ros-lunar-roscpp, ros-lunar-sensor-msgs, ros-lunar-std-msgs, ros-lunar-swri-math-util, ros-lunar-swri-nodelet, ros-lunar-swri-roscpp, ros-lunar-swri-serial-util, ros-lunar-swri-string-util, ros-lunar-tf
Homepage: 
Standards-Version: 3.9.2

Package: ros-lunar-novatel-gps-driver
Architecture: any
Depends: ${shlibs:Depends}, ${misc:Depends}, libboost-all-dev, libpcap0.8-dev, ros-lunar-diagnostic-msgs, ros-lunar-diagnostic-updater, ros-lunar-gps-common, ros-lunar-nav-msgs, ros-lunar-nodelet, ros-lunar-novatel-gps-msgs, ros-lunar-roscpp, ros-lunar-sensor-msgs, ros-lunar-std-msgs, ros-lunar-swri-math-util, ros-lunar-swri-nodelet, ros-lunar-swri-roscpp, ros-lunar-swri-serial-util, ros-lunar-swri-string-util, ros-lunar-tf
Description: Driver for NovAtel receivers

=== debian/rules ===
#!/usr/bin/make -f
# -*- makefile -*-
# Sample debian/rules that uses debhelper.
# This file was originally written by Joey Hess and Craig Small.
# As a special exception, when this file is copied by dh-make into a
# dh-make output file, you may use that output file without restriction.
# This special exception was added by Craig Small in version 0.37 of dh-make.

# Uncomment this to turn on verbose mode.
export DH_VERBOSE=1
# TODO: remove the LDFLAGS override.  It's here to avoid esoteric problems
# of this sort:
#  https://code.ros.org/trac/ros/ticket/2977
#  https://code.ros.org/trac/ros/ticket/3842
export LDFLAGS=
export PKG_CONFIG_PATH=/opt/ros/lunar/lib/pkgconfig
# Explicitly enable -DNDEBUG, see:
# 	https://github.com/ros-infrastructure/bloom/issues/327
export DEB_CXXFLAGS_MAINT_APPEND=-DNDEBUG

%:
	dh $@ -v --buildsystem=cmake

override_dh_auto_configure:
	# In case we're installing to a non-standard location, look for a setup.sh
	# in the install tree that was dropped by catkin, and source it.  It will
	# set things like CMAKE_PREFIX_PATH, PKG_CONFIG_PATH, and PYTHONPATH.
	if [ -f "/opt/ros/lunar/setup.sh" ]; then . "/opt/ros/lunar/setup.sh"; fi && \
	dh_auto_configure -- \
		-DCATKIN_BUILD_BINARY_PACKAGE="1" \
		-DCMAKE_INSTALL_PREFIX="/opt/ros/lunar" \
		-DCMAKE_PREFIX_PATH="/opt/ros/lunar"

override_dh_auto_build:
	# In case we're installing to a non-standard location, look for a setup.sh
	# in the install tree that was dropped by catkin, and source it.  It will
	# set things like CMAKE_PREFIX_PATH, PKG_CONFIG_PATH, and PYTHONPATH.
	if [ -f "/opt/ros/lunar/setup.sh" ]; then . "/opt/ros/lunar/setup.sh"; fi && \
	dh_auto_build

override_dh_auto_test:
	# In case we're installing to a non-standard location, look for a setup.sh
	# in the install tree that was dropped by catkin, and source it.  It will
	# set things like CMAKE_PREFIX_PATH, PKG_CONFIG_PATH, and PYTHONPATH.
	echo -- Running tests. Even if one of them fails the build is not canceled.
	if [ -f "/opt/ros/lunar/setup.sh" ]; then . "/opt/ros/lunar/setup.sh"; fi && \
	dh_auto_test || true

override_dh_shlibdeps:
	# In case we're installing to a non-standard location, look for a setup.sh
	# in the install tree that was dropped by catkin, and source it.  It will
	# set things like CMAKE_PREFIX_PATH, PKG_CONFIG_PATH, and PYTHONPATH.
	if [ -f "/opt/ros/lunar/setup.sh" ]; then . "/opt/ros/lunar/setup.sh"; fi && \
	dh_shlibdeps -l$(CURDIR)/debian/ros-lunar-novatel-gps-driver//opt/ros/lunar/lib/

override_dh_auto_install:
	# In case we're installing to a non-standard location, look for a setup.sh
	# in the install tree that was dropped by catkin, and source it.  It will
	# set things like CMAKE_PREFIX_PATH, PKG_CONFIG_PATH, and PYTHONPATH.
	if [ -f "/opt/ros/lunar/setup.sh" ]; then . "/opt/ros/lunar/setup.sh"; fi && \
	dh_auto_install
